SystemOrganization addCategory: #'XML-Parser-GemstoneCompatibility'!

!PositionableStream methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/14/2014 16:19'!
xmlParserAtBeginning
	^ self atBeginning! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:21'!
asXMLEscapedString
	| stream |

	stream := (self class new: self size) writeStream.
	"to:do: for performance"
	1 to: self size do: [:i | | nextChar |
		(nextChar := self at: i) == $<
			ifTrue: [stream nextPutAll: '&lt;']
			ifFalse: [
				nextChar == $> "needed to escape ]]> in PCDATA"
					ifTrue: [stream nextPutAll: '&gt;']
					ifFalse: [
						nextChar == $&
							ifTrue: [stream nextPutAll: '&amp;']
							ifFalse: [stream nextPut: nextChar]]]].
	^ stream contents.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/16/2014 16:10'!
asXMLString
	^ XMLString string: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/16/2014 16:10'!
asXMLURI
	^ XMLURI fromString: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 3/24/2015 20:07'!
expandWithNamespaceURI: aURI
	aURI size > 0
		ifTrue: [^ 'Q{', aURI, '}', self]
		ifFalse: [^ self]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:23'!
hasPrefixBeforeLocalName
	^ (self
		indexOf: $:
		startingAt: 2) > 0! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:22'!
isNamespaceAttributeName
	^ (self beginsWith: 'xmlns')
		and: [self size = 5
			or: [(self at: 6) == $:]]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:23'!
isQualifiedName: aQualifiedName orLocalName: aLocalName
	"optimized"
	^ self = aQualifiedName
		or: [(aQualifiedName size > aLocalName size)
			and: [self = aLocalName]]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:23'!
isReservedAttributeName
	^ self size > 4
		and: [self beginsWith: 'xml:']! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:23'!
localNameAfterPrefix
	^ self localNameAfterPrefix: self prefixBeforeLocalName! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:24'!
localNameAfterPrefix: aPrefix
	"optimized"
	| prefixSize |

	(prefixSize := aPrefix size) > 0
		ifTrue: [^ self copyFrom: prefixSize + 2 to: self size]
		ifFalse: [^ self]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:24'!
parseXML
	^ XMLDOMParser parse: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:24'!
prefixBeforeLocalName
	"Split the name into namespace prefix
	(Optimized code)"
	| i |

	i := self size.
	[i > 1]
		whileTrue: [
			((self at: i) == $:)
				ifTrue: [^ (self copyFrom: 1 to: i - 1)].
			i := i - 1].
	^ ''.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:24'!
prefixBeforeLocalName: aLocalName
	"optimized"
	| prefixSize |

	(prefixSize := self size - aLocalName size - 1) > 0
		ifTrue: [^ self copyFrom: 1 to: prefixSize]
		ifFalse: [^ '']! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/29/2014 01:24'!
qualifyWithPrefix: aPrefix
	"optimized"
	aPrefix size > 0
		ifTrue: [^ (aPrefix copyWith: $:), self]
		ifFalse: [^ self]! !

!GsFile methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/18/2014 18:27'!
isStream
	^ true! !

!XMLFileStreamWriteStreamFactory class methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/16/2014 16:03'!
fileWriteStreamOn: aPath
	^ (Smalltalk at: #FileStream) write: aPath! !

!XMLOrderedList methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/18/2014 18:31'!
capacity
	^ collection size! !
